#include <winsock2.h>
//#include <windows.h>
#undef _WINDOWS_
#include <afxwin.h>
#include <process.h>

#include "liboddcast.h"
#include <mad.h>
#include "oddcastv3_winamp.h"
#include "resource.h"

#include "MainWindow.h"
#include <bass.h>
CMainWindow *mainWindow;
CWinApp			mainApp;


#include "../SDK/foobar2000.h"

#include "config.h"
#include <math.h>
#include "resource.h"
#undef _WINDOWS_
#include <afxwin.h>
#include "MainWindow.h"

static int isShown = 0;
//static cfg_int oddcast_show_on_startup("dsp_oddcastv2",0);//in 0.1 dB

void inputMetadataCallback(void *gbl, void *pValue) {
    oddcastGlobals *g = (oddcastGlobals *)gbl;
    mainWindow->inputMetadataCallback(g->encoderNumber, pValue);
}
void outputStatusCallback(void *gbl, void *pValue) {
    oddcastGlobals *g = (oddcastGlobals *)gbl;
    mainWindow->outputStatusCallback(g->encoderNumber, pValue);
}
void writeBytesCallback(void *gbl, void *pValue) {
    oddcastGlobals *g = (oddcastGlobals *)gbl;
    mainWindow->writeBytesCallback(g->encoderNumber, pValue);
}
void outputServerNameCallback(void *gbl, void *pValue) {
    oddcastGlobals *g = (oddcastGlobals *)gbl;
    mainWindow->outputServerNameCallback(g->encoderNumber, pValue);
}
void outputBitrateCallback(void *gbl, void *pValue) {
    oddcastGlobals *g = (oddcastGlobals *)gbl;
    mainWindow->outputBitrateCallback(g->encoderNumber, pValue);
}
void outputStreamURLCallback(void *gbl, void *pValue) {
    oddcastGlobals *g = (oddcastGlobals *)gbl;
    mainWindow->outputStreamURLCallback(g->encoderNumber, pValue);
}


int oddcastv3_init(oddcastGlobals *g)
{

	setServerStatusCallback(g, outputStatusCallback);
	setGeneralStatusCallback(g, NULL);
	setWriteBytesCallback(g, writeBytesCallback);
	setBitrateCallback(g, outputBitrateCallback);
	setServerNameCallback(g, outputServerNameCallback);
	setDestURLCallback(g, outputStreamURLCallback);

	readConfigFile(g);
	setFrontEndType(g, FRONT_END_ODDCAST_PLUGIN);
	return 1;
}

void initializeIt()
{
		char filename[512],*p;
		char	directory[1024] = "";
		char currentDir[1024] = "";


		memset(filename, '\000', sizeof(filename));
		GetModuleFileName(NULL,filename,sizeof(filename));
		strcpy(currentDir, filename);
		char *pend;
		pend = strrchr(currentDir, '\\');
		if (pend) {
			*pend = '\000';
		}
		p = filename+lstrlen(filename);
		while (p >= filename && *p != '\\') p--;
		p++;

		char	logFile[1024] = "";
		memset(logFile, '\000', sizeof(logFile));
		strcpy(logFile, "oddcastv3_foo");

        LoadConfigs(currentDir, logFile);

        AfxWinInit(core_api::get_my_instance(), NULL, "", SW_HIDE);

        mainWindow = new CMainWindow();

        mainWindow->InitializeWindow();

        strcpy(mainWindow->m_currentDir, currentDir);

        //mainWindow->Create((UINT)IDD_ODDCAST, mainApp.GetMainWnd());    
        //mainWindow->Create((UINT)IDD_ODDCAST, CWnd::FromHandle(core_api::get_main_window()));    
        mainWindow->Create((UINT)IDD_ODDCAST, AfxGetMainWnd());
        int x = getLastX();
        int y = getLastY();
        if (x < 0) {
            x = 0;
        }
        if (y < 0) {
            y = 0;
        }

        mainWindow->SetWindowPos(NULL, x, y, -1, -1, SWP_NOSIZE | SWP_SHOWWINDOW);

        modeless_dialog_manager::add(mainWindow->m_hWnd);
        modeless_dialog_manager::add(mainWindow->configDialog->m_hWnd);   
        modeless_dialog_manager::add(mainWindow->editMetadata->m_hWnd);

        mainWindow->SetIcon(mainApp.LoadIcon(IDR_MAINFRAME), TRUE);
        mainWindow->ShowWindow(SW_HIDE);
        

        initializeOddcastV3();
}

class dsp_oddcastv3 : public dsp_i_base
{
public:
	virtual GUID get_guid()
	{
        // {CEEE844A-CE07-4d0a-9587-347E5401F24C}
        static const GUID guid = 
        { 0xceee844a, 0xce07, 0x4d0a, { 0x95, 0x87, 0x34, 0x7e, 0x54, 0x1, 0xf2, 0x4c } };
		return guid;
	}

	virtual const char * get_name() { return "Oddcast V3";}

	virtual bool on_chunk(audio_chunk *chunk)
	{
		if (!isShown) {
			mainWindow->ShowWindow(SW_SHOW);
        //    initializeIt();
			isShown = 1;
		}
        if (!LiveRecordingCheck()) {
            int nsamples  = chunk->get_sample_count();
            int nch = chunk->get_channels();
            int srate = chunk->get_srate();
            float *samples = (float *)malloc(nsamples*nch*sizeof(float));
            audio_sample *psample = chunk->get_data();
            for (int i=0;i<nsamples*nch;i++) {
                audio_sample sample = *psample++;
                samples[i] = (sample);
            }
            handleAllOutput((float *)samples, nsamples, nch, srate);
            if (samples) {
                free(samples);
            }
        }
  	    return true;
	}

};
class initquit_oddcast : public initquit
{
public:
	virtual void on_init()
	{
		int a = 1;
        initializeIt();
	}
    virtual void on_system_shutdown()
    {
        ;
    }
	virtual void on_quit()
	{
        modeless_dialog_manager::remove(mainWindow->m_hWnd);
        modeless_dialog_manager::remove(mainWindow->configDialog->m_hWnd);
        modeless_dialog_manager::remove(mainWindow->editMetadata->m_hWnd);
        mainWindow->DestroyWindow();
	}

	static GUID get_class_guid();
};


static playlist_entry_i now_playing;

class oddcast_play_callback_ui : public play_callback
{
	virtual void on_playback_starting()
	{
	}
	virtual void on_playback_new_track(metadb_handle * track)
	{
		string8		out = "";
		string8		fullTitle = "";
       	char	songTitle[1024] = "";
	    char	songTitle2[1024] = "";
	    static	char currentTitle[1024] = "";
	    int		windowTitle = 1;
        char    newTitle[2046] = "";


        if (track) {
            track->handle_lock();
            const file_info * info = track->handle_query_locked();
            if (info) {
                int numInfos = info->meta_get_count();
                for (int i=0;i<numInfos;i++) {
                    const char *pName = info->meta_enum_name(i);
                    const char *pValue = info->meta_enum_value(i);
                    char *buffer;
                    int bufferlen = 0;
                    bufferlen = strlen(pName) + strlen(pValue) + strlen("=") + 1;
                    buffer = (char *)calloc(1, bufferlen);
                    sprintf(buffer, "%s=%s", pName, pValue);
                    string8 theout = "";
                    theout.add_string(buffer);
                    addComment((char *)(const char *)string_ansi_from_utf8(theout));
                    free(buffer);
                }
            }
            track->handle_unlock();
		    track->handle_query_meta_field("ARTIST", 0, out);
		    fullTitle.add_string(out);
		    track->handle_query_meta_field("TITLE", 0, out);
		    fullTitle.add_string(" - ");
		    fullTitle.add_string(out);

    	    setMetadataFromMediaPlayer((char *)(const char *)string_ansi_from_utf8(fullTitle));
        }
	}
	virtual void on_playback_stop(play_control::stop_reason reason)
	{
		;
	}
	virtual void on_playback_seek(double time)
	{
		;
	}
	virtual void on_playback_pause(int state)
	{
		;
	}
	virtual void on_playback_edited(metadb_handle * track)
	{
		;
	}
	virtual void on_playback_dynamic_info(const file_info * info,bool b_track_change)
	{
		;
	}
	virtual void on_volume_change(int new_val) {};

};

static service_factory_single_t<dsp,dsp_oddcastv3> odd_foo;
static service_factory_single_t<initquit,initquit_oddcast> odd_foo_init;
static service_factory_single_t<play_callback,oddcast_play_callback_ui> odd_foo_play_callback;
